package com.classroom.assignment.repository;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.classroom.assignment.entity.Todo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

@Repository
public class TodoDaoImpl implements TodoDao {

  private final JdbcTemplate jdbcTemplate;

  @Autowired
  public TodoDaoImpl(JdbcTemplate jdbcTemplate) {
    this.jdbcTemplate = jdbcTemplate;
  }

  @Override
  public List<Todo> selectAll() {
    String sql = "SELECT id, todo, checked FROM TODO";
    List<Map<String, Object>> resultList = jdbcTemplate.queryForList(sql);
    List<Todo> list = new ArrayList<>();
    for (Map<String, Object> result : resultList) {
      Todo todo = new Todo();
      todo.setId((int) result.get("id"));
      todo.setTodo((String) result.get("todo"));
      todo.setChecked((boolean) result.get("checked"));

      list.add(todo);
    }

    return list;
  }

  @Override
  public List<Todo> selectByNotChecked() {
    String sql = "SELECT id, todo, checked FROM TODO WHERE checked = false";
    List<Map<String, Object>> resultList = jdbcTemplate.queryForList(sql);
    List<Todo> list = new ArrayList<>();
    for (Map<String, Object> result : resultList) {
      Todo todo = new Todo();
      todo.setId((int) result.get("id"));
      todo.setTodo((String) result.get("todo"));
      todo.setChecked((boolean) result.get("checked"));

      list.add(todo);
    }

    return list;
  }

  @Override
  public int insertTodo(String todo) {
    return jdbcTemplate.update("INSERT INTO TODO (todo, checked) VALUES(?, false)",
        todo);
  }

  @Override
  public int updateTodo(int id, boolean checked) {
    return jdbcTemplate.update("UPDATE TODO SET checked = ? WHERE id = ?",
        checked, id);
  }

  @Override
  public int deleteTodo(int id) {
    return jdbcTemplate.update("DELETE FROM TODO WHERE id = ?", id);
  }

}
