package com.classroom.assignment.service;

import java.util.List;
import com.classroom.assignment.repository.TodoDao;
import org.springframework.stereotype.Service;
import com.classroom.assignment.entity.Todo;
import com.classroom.assignment.exception.NotDeleteException;
import com.classroom.assignment.exception.NotInsertException;
import com.classroom.assignment.exception.NotUpdateException;

@Service
public class TodoServiceImpl implements TodoService {

  private final TodoDao dao;

  public TodoServiceImpl(TodoDao dao) {
    this.dao = dao;
  }

  @Override
  public List<Todo> selectAll() {
    List<Todo> list = dao.selectAll();
    return list;
  }

  @Override
  public List<Todo> selectByNotChecked() {
    List<Todo> list = dao.selectByNotChecked();
    return list;
  }

  @Override
  public void insertTodo(String todo) {
    int result = dao.insertTodo(todo);
    if (result == 0) {
      throw new NotInsertException();
    }
  }

  @Override
  public void updateTodo(int id, boolean checked) {
    int result = dao.updateTodo(id, checked);
    if (result == 0) {
      throw new NotUpdateException();
    }
  }

  @Override
  public void delete(int id) {
    int result = dao.deleteTodo(id);
    if (result == 0) {
      throw new NotDeleteException();
    }
  }
}
